Syncfusion AI Assistant

How can I help you?

Filter list items in the ListView in Vue ListView component

21 Feb 20256 minutes to read

The filtered data can be displayed in the ListView component depending on user inputs using the DataManager. Refer to the following steps to render the ListView with filtered data.

  • Render a textbox to get user input for filtering data.

  • Render ListView with dataSource, and set the sortOrder property.

  • Bind the keyup event for the textbox to perform the filtering operation. To filter list data, pass the list data source to the DataManager, manipulate the data using the executeLocal method, and then update the ListView’s dataSource with the filtered data.

<template>
  <div class="control-section">
    <div id='sample'>
      <input class="e-input" type="text" id='textbox' ref='textboxEle' placeholder="Filter" title="Type in a name"
        @keyup='onkeyup' />
      <!-- ListView element -->
      <ejs-listview id='list' ref='listObj' :dataSource='data' :fields='fields' sortOrder='Ascending'>
      </ejs-listview>
    </div>
  </div>
</template>

<script setup>

import { ListViewComponent as EjsListview } from "@syncfusion/ej2-vue-lists";
import { DataManager, Query } from "@syncfusion/ej2-data";
import {ref} from 'vue';

const listObj = ref(null);
const textboxEle = ref(null);

const data = [
  { text: "Hennessey Venom", id: "list-01" },
  { text: "Bugatti Chiron", id: "list-02" },
  { text: "Bugatti Veyron Super Sport", id: "list-03" },
  { text: "SSC Ultimate Aero", id: "list-04" },
  { text: "Koenigsegg CCR", id: "list-05" },
  { text: "McLaren F1", id: "list-06" }
];
const fields = { text: "text", id: "id" };

const onkeyup = () => {
  let keyupvalue = textboxEle.value.value;
  let Filtereddata = new DataManager(data).executeLocal(new Query().where("text", "startswith", keyupvalue, true));
  if (!keyupvalue) {
    listObj.value.ej2Instances.dataSource = data.slice();
  } else {
    listObj.value.ej2Instances.dataSource = Filtereddata;
  }
};

</script>
<style>
#list {
  box-shadow: 0 1px 4px #ddd;
  border-bottom: 1px solid #ddd;
}

#sample {
  height: 220px;
  margin: 0 auto;
  display: table;
}
</style>
<template>
  <div class="control-section">
    <div id = 'sample'>
      <input class="e-input" type="text" id='textbox' ref='textboxEle' placeholder="Filter" title="Type in a name" @keyup='onkeyup' />
      <!-- ListView element -->
      <ejs-listview id='list' ref='listObj' :dataSource='data' :fields='fields' sortOrder='Ascending'>
      </ejs-listview>
    </div>
  </div>
</template>
<script>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";
import { DataManager, Query } from "@syncfusion/ej2-data";

export default {
name: "App",
components: {
"ejs-listview":ListViewComponent
},
  data: function() {
    return {
      data: [
        { text: "Hennessey Venom", id: "list-01" },
        { text: "Bugatti Chiron", id: "list-02" },
        { text: "Bugatti Veyron Super Sport", id: "list-03" },
        { text: "SSC Ultimate Aero", id: "list-04" },
        { text: "Koenigsegg CCR", id: "list-05" },
        { text: "McLaren F1", id: "list-06" }],
      fields: { text: "text", id: "id" },
    };
  },
  methods:{
   onkeyup: function(){
      let keyupvalue = this.$refs.textboxEle.value;
      let data = new DataManager(this.data).executeLocal(new Query().where("text", "startswith", keyupvalue, true));
      if (!keyupvalue) {
        this.$refs.listObj.ej2Instances.dataSource = this.data.slice();
      } else {
        this.$refs.listObj.ej2Instances.dataSource = data;
      }
    }
  }
}
</script>
<style>
#list {
  box-shadow: 0 1px 4px #ddd;
  border-bottom: 1px solid #ddd;
}
#sample {
  height: 220px;
  margin: 0 auto;
  display: table;
}
</style>

In this demo, data has been filtered with starting character of the list items. ou can also filter list items with an ending character by passing endswith in the where clause instead of startswith.

Filter list items in the ListView in React ListView component

23 Jan 20259 minutes to read

The filtered data can be displayed in the ListView component depending on user inputs using the DataManager. Follow these steps to render the ListView with filtered data:

  • Render a textbox to get input for filtering data.

  • Render the ListView with dataSource, and set the sortOrder property.

  • Bind the keyup event to the textbox to perform filtering operation. To filter list data:

    1. Pass the list data source to the DataManager.
    2. Manipulate the data using the executeLocal method.
    3. Update the filtered data as the ListView’s dataSource.
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DataManager, Query } from "@syncfusion/ej2-data";
import { ListViewComponent } from "@syncfusion/ej2-react-lists";
function App() {
    let list = [
        { text: "Hennessey Venom", id: "list-01" },
        { text: "Bugatti Chiron", id: "list-02" },
        { text: "Bugatti Veyron Super Sport", id: "list-03" },
        { text: "SSC Ultimate Aero", id: "list-04" },
        { text: "Koenigsegg CCR", id: "list-05" },
        { text: "McLaren F1", id: "list-06" }
    ];
    let fields = { text: "text", id: "id" };
    const [state, SetState] = React.useState({ listData: list });
    function onKeyUp(e) {
        let value = e.target.value;
        let data = new DataManager(state.listData).executeLocal(new Query().where("text", "startswith", value, true));
        if (!value) {
            SetState({
                listData: list
            });
        }
        else {
            SetState({
                listData: data
            });
        }
    }
    return (<div id="sample">
        <input className="e-input" type="text" id="textbox" placeholder="Filter" onKeyUp={onKeyUp.bind(this)} title="Type in a name" />
        <ListViewComponent id="list" dataSource={state.listData} fields={fields} sortOrder="Ascending" />
    </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById("element"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DataManager, Query, ODataV4Adaptor } from "@syncfusion/ej2-data";
import { ListViewComponent } from "@syncfusion/ej2-react-lists";

function App() {
  let list: any[] = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" }
  ];
  let fields: Object = { text: "text", id: "id" };
  const [state, SetState] = React.useState({ listData: list });
  function onKeyUp(e: any) {
    let value = e.target.value;
    let data = new DataManager(state.listData).executeLocal(
      new Query().where("text", "startswith", value, true)
    );
    if (!value) {
      SetState({
        listData: list
      });
    } else {
      SetState({
        listData: data
      });
    }
  }

  return (
    <div id="sample">
      <input
        className="e-input"
        type="text"
        id="textbox"
        placeholder="Filter"
        onKeyUp={onKeyUp.bind(this)}
        title="Type in a name"
      />
      <ListViewComponent
        id="list"
        dataSource={state.listData}
        fields={fields}
        sortOrder="Ascending"
      />
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById("element"));
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: "Helvetica Neue", "calibiri";
  font-size: 14px;
  top: 45%;
  left: 45%;
}

#list {
  box-shadow: 0 1px 4px #ddd;
  border-bottom: 1px solid #ddd;
}

#sample {
  height: 220px;
  margin: 0 auto;
  display: table;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

In this demo, data has been filtered by the starting character of the list items. You can also filter list items by their ending character by passing endswith in the where clause instead of startswith.

Syncfusion AI Assistant

How can I help you?

How to Filter Items in Angular ListView Using DataManager

10 Sep 20254 minutes to read

You can dynamically filter items in the Angular ListView component based on user input using Syncfusion’s DataManager. This guide walks you through rendering a searchable ListView with real-time filtering.

Steps to Implement Filtering

  1. Render a TextBox to capture user input for filtering.
  2. Configure the ListView with a dataSource and set the sortOrder property.
  3. Bind the keyup event to the TextBox to trigger filtering logic.
  4. Use DataManager and Query.where to filter the data locally via the executeLocal method.
  5. Update the ListView’s dataSource with the filtered result.

Filtering Variants

  • Starts with: Default behavior using Query.where(..., 'startswith', ...)
  • Ends with: Replace 'startswith' with 'endswith'
  • Contains: Use 'contains' for substring matching
  • Case-insensitive: Normalize input and data using .toLowerCase() before filtering
  • Multiple conditions: Chain multiple Query.where() clauses
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ListViewModule } from '@syncfusion/ej2-angular-lists'
import { Component, ViewChild } from "@angular/core";
import { ListViewComponent } from "@syncfusion/ej2-angular-lists";
import { enableRipple } from "@syncfusion/ej2-base";
import { DataManager, Query, ODataV4Adaptor } from "@syncfusion/ej2-data";
enableRipple(true);

@Component({
  imports: [
    ListViewModule
  ],
  standalone: true,
  selector: 'my-app',
  template: `<div id="sample">
            <input #textbox class="e-input" type="text" id="textbox" placeholder="Filter" title="Type in a name" (keyup)=onkeyup($event) />
            <ejs-listview #list id='list' [dataSource]='listData' [fields]='fields' [sortOrder]='Ascending'></ejs-listview>
        </div>`,
  styles: [`
        #list {
  box-shadow: 0 1px 4px #ddd;
  border-bottom: 1px solid #ddd;
}
#sample {
  height: 220px;
  margin: 0 auto;
  display: table;
}
        `]
})

export class AppComponent {
  public listData: Object = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" }
  ];

  public fields: Object = { text: "text", id: "id" };
  @ViewChild('list')
  listObj?: ListViewComponent;
  @ViewChild('textbox') textboxEle: any;
  Ascending: any;
  onkeyup(event: any) {
    let value = this.textboxEle.nativeElement.value;
    let data = new DataManager(this.listData).executeLocal(new Query().where("text", "startswith", value, true));
    if (!value) {
      (this.listObj as ListViewComponent).dataSource = (this.listData as any).slice();
    } else {
      ((this.listObj as ListViewComponent).dataSource as any) = data;
    }
    this.listObj?.dataBind();
  }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-popups/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material3.css';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

In this demo, data has been filtered with starting character of the list items. You can also filter list items with ending character by passing the endswith in where clause instead of startswith.